------------------------------------------------------------------
------------------ Super Meter - Region Options ------------------
------------------------------------------------------------------

SuperMeter_region01 = "Absorb to heal converter disabled"
SuperMeter_region02 = "Absorb to heal converter enabled"

SuperMeter_region03 = "Actual ability data mode enabled"
SuperMeter_region04 = "Full ability data mode enabled"

SuperMeter_region05 = "Group combat detector disabled"
SuperMeter_region06 = "Group combat detector enabled"

SuperMeter_region07 = "Ability tooltip mouse over display disabled"
SuperMeter_region08 = "Ability tooltip mouse over display enabled"

SuperMeter_region09 = "Performance mode disabled"
SuperMeter_region10 = "Performance mode enabled"

SuperMeter_region11 = "Player session logs disabled"
SuperMeter_region12 = "Player session logs enabled"

SuperMeter_region13 = "Self colour coded blue disabled"
SuperMeter_region14 = "Self colour coded blue enabled"

SuperMeter_region15 = "Unit merging by matching name disabled"
SuperMeter_region16 = "Unit merging by matching name enabled"

SuperMeter_region17 = "Unit rank display mode disabled"
SuperMeter_region18 = "Unit rank display mode enabled"

SuperMeter_region19 = "Frame grow up mode disabled"
SuperMeter_region20 = "Frame grow up mode enabled"

SuperMeter_region21 = "You are PvP flagged, Super Meter PvP mode enabled."
SuperMeter_region22 = "is now active starting a new session."

function SuperMeter.Help()
	if not SuperMeter_enabled then return end

	local text = ""

	text = text .. "Left mouse click the 'Mode' labels to change mode sorting.\n"
	text = text .. "Right mouse click the 'Mode' labels to change modes using the mode menu.\n"
	text = text .. "To export stats left mouse click on the 'Total' frame in any mode column.\n"
	text = text .. "To toggle total or group vs self left mouse click the 'Total' frame.\n"
	text = text .. "To toggle minimal frame mode right mouse click the 'Total' frame.\n"
	text = text .. "To display all the units in combat left mouse click the 'Time' frame.\n"
	text = text .. "The session manager can be toggled by right mouse clicking the 'Index' or 'Menu'.\n"
	text = text .. "The session 'Index' and unit 'Slots' can be changed using the mouse wheel.\n"
	text = text .. "To move the mini menu left mouse down and hold any blue corner and drag.\n"
	text = text .. "The mini menu position can be reset by middle mouse clicking the 'Menu' title.\n"
	text = text .. "Left mouse click the units frame to toggle that units combat log.\n"
	text = text .. "Right mouse click the units frame to cycle the units display style.\n"
	text = text .. "Left mouse click a unit in any column to see the basic ability breakdown.\n"
	text = text .. "Right mouse click a unit in any column to see the advanced ability breakdown.\n"
	text = text .. "Left and right mouse click ability tooltip commands can be used in combination.\n"
	text = text .. "Tooltips are mode based and ability data changes with the mode that you select.\n"
	text = text .. "Tooltips can be moved when in sticky mode using left mouse down and drag.\n"
	text = text .. "Change log targets by selecting a player and left mouse clicking the target title.\n"
	text = text .. "Switch to the death log from a players log by left mouse clicking the target title.\n"

	return text
end

function SuperMeter.Tooltip(item)
	local unit = SuperMeter.Interface.Unit()
	local info1 = SuperMeter_logEnabled
	local info2 = SuperMeter_converter
	local info3 = SuperMeter_group
	local info4 = SuperMeter_full

	if not info1 then info1 = "False" else info1 = "True" end
	if not info2 then info2 = "False" else info2 = "True" end
	if not info3 then info3 = "False" else info3 = "True" end
	if not info4 then info4 = "Actual" else info4 = "Full" end

	if item == "Main" then
		local text = "Super Meter v " .. SuperMeter.Version .. " \n\nLeft Hold And Drag To Move\nMiddle Click Toggles The Font Size\nRight Click Changes Growth Direction\nMouse Wheel Changes The Frame Width\n\n"
		text = text .. "Absorb To Heal Converter Enabled: " .. info2 .. "\nGroup Combat Detector Enabled: " .. info3 .. "\nPlayer Session Logs Enabled: " .. info1 .. "\nData Collection Mode: " .. info4
		return text
	end

	if item == "Log" then
		local text = "Player Session Logs\n\nLeft Click To Open The Player Session Logs"
		return text
	end

	if item == "Force" then
		local text = "Force Combat\n\nLeft Click To Force Start Or Stop Combat"
		return text
	end

	if item == "Unit" then
		if unit and unit.combatlog[1] then
			local text = "Left Click Opens " .. unit.name .. "'s Combat Log"
			return text
		end
	end

	if item == "Clear" then
		local text = "Clear Data\n\nLeft Click To Clear All Collected Data"
		return text
	end

	if item == "New" then
		local text = "New Session\n\nLeft Click To Start A New Session"
		return text
	end

	if item == "Help" then
		local text = "Help File\n\nLeft Click To Open The Help File"
		return text
	end
end

function SuperMeter.Describe(mode1, mode2)
	local show = SuperMeter_showPlayer
	local o = SuperMeter.Interface

	local desc = false
	local mode = false

	if mode1 then
		mode = SuperMeter_mode1
	end

	if mode2 then
		mode = SuperMeter_mode2
	end

	if mode == "DPS" then
		desc = "Damage P/S"
	elseif mode == "DMG" then
		desc = "Damage"
	elseif mode == "HPS" then
		desc = "Healing P/S"
	elseif mode == "HLG" then
		desc = "Healing"
	elseif mode == "OPS" then
		desc = "Overhealing P/S"
	elseif mode == "OHG" then
		desc = "Overhealing"
	elseif mode == "OKL" then
		desc = "Overkill"
	elseif mode == "DTN" then
		desc = "Damage Taken"
	elseif mode == "HTN" then
		desc = "Healing Taken"
	elseif mode == "ASB" then
		desc = "Absorbed Damage"
	elseif mode == "AVD" then
		desc = "Avoided Damage"
	elseif mode == "BLK" then
		desc = "Blocked Damage"
	elseif mode == "DFT" then
		desc = "Deflected Damage"
	elseif mode == "MSD" then
		desc = "Missed Damage"
	end

	if desc and not show then
		o.totaltext1:SetText(desc)
		SuperMeter_modedesc = true
	end
end

function SuperMeter.Mode()
	local o = SuperMeter.Interface
	local height = 20 * 14

	o.modeselectbg:SetHeight(height + 10 + 2.00)
	o.modeselect:SetHeight(height + 2.0 + 0.688)

	o.mode13select:SetText("Deflected Damage")
	o.mode10select:SetText("Absorbed Damage")
	o.mode8select:SetText("Overhealing P/S")
	o.mode11select:SetText("Avoided Damage")
	o.mode12select:SetText("Blocked Damage")
	o.mode14select:SetText("Missed Damage")
	o.mode7select:SetText("Healing Taken")
	o.mode3select:SetText("Damage Taken")
	o.mode5select:SetText("Healing P/S")
	o.mode9select:SetText("Overhealing")
	o.mode1select:SetText("Damage P/S")
	o.mode4select:SetText("Overkill")
	o.mode6select:SetText("Healing")
	o.mode2select:SetText("Damage")
end

function SuperMeter.Options()
	local o = SuperMeter.Interface

	o.cmd:SetVisible(not o.cmd:GetVisible())
	o.cmdperformance:SetText("Performance")
	o.cmdconverter:SetText("Converter")
	o.cmdmouseover:SetText("Mouseover")
	o.cmdswitch:SetText("Toggle Addon")
	o.cmdtoggle:SetText("Frame Toggle")
	o.cmdgroup:SetText("Group Combat")
	o.cmdalpha:SetText("Frame Alpha")
	o.cmdreset:SetText("Reset Addon")
	o.cmdself:SetText("Self Colour")
	o.cmdunify:SetText("Unit Merge")
	o.cmdlog:SetText("Player Logs")
	o.cmdfull:SetText("Full Mode")
	o.cmdhelp:SetText("Help File")
	o.cmdrank:SetText("Unit Rank")
end

function SuperMeter.Metrics(request)
	local font = SuperMeter_fontSize

	local height = 0.0
	local offset = 0.0
	local full = 0.0
	local gap = 0.0

	if font then
		if font == 14 then
			height = 18.0000
		else
			height = 16.6200
		end
		offset = 0.6888 * 2
		gap = 2.0000
	end

	if height > 0 then
		SuperMeter_interval = height + gap
		full = height + gap
	end

	if request == "height" then
		return height
	end

	if request == "offset" then
		return offset
	end

	if request == "full" then
		return full
	end

	if request == "gap" then
		return gap
	end
end